library(MASS)
library(gnlm)
library(growth)

nind <- 40
clustsize <- 5
corr <- 0.8
var <- 5

Sigma <- matrix(var*corr,ncol=clustsize,nrow=clustsize)
diag(Sigma) <- rep(var,clustsize)
y <- mvrnorm(nind,rep(0,clustsize),Sigma)
reps <- rmna(restovec(y))

gnlr(reps,pmu=0,psh=2)
elliptic(reps,pre=1)
print(z <- gnlr(reps,mu=~individuals,pmu=rep(0,nind),psh=2),corr=F)

plot(density(c(z$coef[2:nind],-sum(z$coef[2:nind]))),
  main=substitute(list(n==nind,m==clustsize,sigma^2==var,rho==corr),
   list(corr=corr,var=var,nind=nind,clustsize=clustsize)))
lines(seq(-4,4,by=0.1),dnorm(seq(-4,4,by=0.1),0,sqrt(var)),lty=3)

#plot(seq(-4,4,by=0.1),dnorm(seq(-4,4,by=0.1),0,sqrt(var)),lty=3,
#  main=substitute(list(n==nind,m==clustsize,sigma^2==var,rho==corr),
#  list(corr=corr,var=var,nind=nind,clustsize=clustsize)),type="l")
#lines(density(c(z$coef[2:nind],-sum(z$coef[2:nind]))))
