library(repeated)
library(growth)
library(gnlm)
dose <- c(9,12,4,9,11,10,2,11,12,9,9,9,4,9,11,9,14,7,9,8)
#y <- round(rgamma(20,scale=2,2+0.3*dose)+rep(rnorm(4,0,4),rep(5,4)),1)
y <- c(8.7,11.5,11.4,27.4,12.1,4.4,1.9,17.4,4.5,2.7,5.7,10.5,11.2,7.0,4.1,
	16.4,14.7,8.8,21.0,17.2)
resp <- restovec(matrix(y, nrow=4, byrow=T), name="y", delta=0.1)
reps <- rmna(resp, tvcov=tvctomat(matrix(dose, nrow=4, byrow=T), name="dose"))

gnlr(reps, mu=~dose, pmu=c(9,0.3), psh=1) # 111.4953
gnlr(reps, mu=~dose+individuals, pmu=c(9,0.3,0,0,0), psh=1) # 112.5700
elliptic(reps, model=~dose+individuals, preg=c(12,0.6,0,0,0)) # 112.5700
elliptic(reps, model=~dose, preg=c(0,0.6), pre=4) # 114.6833
hnlmix(reps, mu=~a+rand+b*dose, random="rand", pmu=c(10,0.25),
	pshape=3.44, prandom=c(3,-4,-3,4)) # 112.7626

gnlr(reps, distribution="gamma", mu=~dose, pmu=c(9,0.3),psh=1) # 112.5549
gnlr(reps, distribution="gamma", mu=~dose+individuals, pmu=c(9,0.3,0,0,0),
	psh=1) # 109.6771
gnlmm(reps, distribution="gamma", mu=~dose, pmu=c(9,0.3),
	psh=1, psd=0.3) # 112.7748
hnlmix(reps, distribution="gamma", mu=~a+rand+b*dose, random="rand",
	pmu=c(9,0.5), pshape=3.2, prandom=c(3,-4,-3,4)) # 109.8287

gnlr(reps,mu=~exp(linear),linear=~dose,pmu=c(9,0.3),psh=50) # 114.5245
gnlr(reps,mu=~exp(linear),linear=~dose+individuals,
	pmu=c(9,0.3,0,0,0),psh=50) # 112.6341
gnlmm(reps, distribution="normal", mu=~exp(a+b*dose), pmu=c(2,0.01),
	psh=3.7, psd=1) # 114.7018
hnlmix(reps, mu=~exp(a+rand+b*dose), random="rand",
	pmu=c(2.6,0.01), pshape=3.2, prandom=0) # 112.6341

gnlr(reps, distribution="gamma",mu=~exp(linear),linear=~dose+individuals,
	pmu=c(9,0.3,0,0,0),psh=1) # 110.6946
gnlmm(reps, distribution="gamma", mu=~exp(a+b*dose), pmu=c(2,0.03),
	psh=1, psd=0.3) # 112.8537
hnlmix(reps, distribution="gamma", mu=~exp(a+rand+b*dose), random="rand",
	pmu=c(2.6,0.01), pshape=3.2, prandom=0) # 110.7109

gnlmix(reps, distribution="gamma", mixture="logistic",
	mu=~exp(a+rand+b*dose), random="rand", pmu=c(2,0.03),
	pshape=1.1, pmix=-0.1) # 113.1303
hnlmix(reps, distribution="gamma", mixture="logistic",
	mu=~exp(a+rand+b*dose), random="rand",
	pmu=c(2,0.01), pshape=1.4, prandom=0) # 110.7109

gnlmix(reps, distribution="gamma", mixture="gamma",
	mu=~exp(a*rand+b*dose), random="rand", pmu=c(2,0.04),
	pshape=1.24, pmix=3.5) # 112.8904
hnlmix(reps, distribution="gamma", mixture="gamma",
	mu=~exp(a*rand+b*dose), random="rand",
	pmu=c(2.6,0.01), pshape=3.2, prandom=1) # 110.7312
gnlmix(reps, distribution="gamma", mixture="gamma",
	mu=~exp(a+b*dose)*rand, random="rand", pmu=c(2,0.04),
	pshape=1.24, pmix=3.5) # 112.8337
hnlmix(reps, distribution="gamma", mixture="gamma",
	mu=~exp(a+b*dose)*rand, random="rand",
	pmu=c(2.6,0.01), pshape=3.2, prandom=1) # 110.7305

gnlmix(reps, distribution="gamma", mixture="inverse Gauss",
	mu=~exp(a*rand+b*dose), random="rand", pmu=c(2,0.04),
	pshape=1.24, pmix=3.5) # 112.9143
hnlmix(reps, distribution="gamma", mixture="inverse Gauss",
	mu=~exp(a*rand+b*dose), random="rand",
	pmu=c(2,0.01), pshape=3.2, prandom=c(2,1,1.5,2)) # 110.7112

gnlmix(reps, distribution="gamma", mixture="Weibull",
 	mu=~exp(a*rand+b*dose), random="rand", pmu=c(2,0.04),
 	pshape=1.24, pmix=3.5) # 112.8095
hnlmix(reps, distribution="gamma", mixture="Weibull",
	mu=~exp(a+rand+b*dose), random="rand",
	pmu=c(2.6,0.01), pshape=3, prandom=c(2,1,1.5,2)) # 110.6983
