library(repeated)
library(growth)
library(gnlm)
dose <- c(9,12,4,9,11,10,2,11,12,9,9,9,4,9,11,9,14,7,9,8)
#y <- round(rgamma(20,2,scale=exp(-1+0.3*dose+rep(rnorm(4,0,1),rep(5,4)))/2),1)
y <- c(2.7,1.4,0.2,1.5,4.4,1.5,0.3,7.3,22.0,11.3,6.0,3.7,2.3,6.6,1.3,
	2.5,6.2,0.4,0.7,1.5)
resp <- restovec(matrix(y, nrow=4, byrow=T), name="y", delta=0.1)
reps <- rmna(resp, tvcov=tvctomat(matrix(dose, nrow=4, byrow=T), name="dose"))

gnlr(reps, mu=~dose, pmu=c(9,0.3), psh=1) # 107.5005
gnlr(reps, mu=~dose+individuals, pmu=c(9,0.3,0,0,0), psh=1) # 105.9718
elliptic(reps, model=~dose+individuals, preg=c(12,0.6,0,0,0)) # 105.9718
elliptic(reps, model=~dose, preg=c(0,0.6), pre=4) # 107.8659
hnlmix(reps, mu=~b*dose+rand, random="rand", pmu=0.25,
	pshape=3.44, pmix=-1, prandom=c(13,4,6,14)) # 111.407

gnlr(reps, distribution="gamma",mu=~exp(linear),linear=~dose,
	pmu=c(9,0.3),psh=1) # 93.0496
gnlr(reps, distribution="gamma",mu=~exp(linear),linear=~dose+individuals,
	pmu=c(9,0.3,0,0,0),psh=1) # 89.48216

gnlmm(reps, distribution="gamma", mu=~exp(a+b*dose), pmu=c(-1,0.26),
	psh=0.3, psd=0.2) # 93.17386
hnlmix(reps, distribution="gamma", mu=~exp(b*dose+rand), random="rand",
	pmu=0.25, pshape=0.3, pmix=-1, prandom=-1.5) # 96.35186

gnlmix(reps, distribution="gamma", mixture="gamma",
	mu=~exp(a*rand+b*dose), random="rand", pmu=c(-1.5,0.3),
	pshape=0.75, pmix=2) # 92.36607
hnlmix(reps, distribution="gamma", mixture="gamma",
	mu=~exp(b*dose+rand), random="rand",
	pmu=0.25, pshape=0.7, pmix=-1, prandom=-1.5) # 96.34273

gnlmix(reps, distribution="gamma", mixture="Weibull",
	mu=~exp(a*rand+b*dose), random="rand", pmu=c(-1.5,0.3),
	pshape=0.7, pmix=1) # 92.31308
hnlmix(reps, distribution="gamma", mixture="Weibull",
	mu=~exp(b*dose+rand), random="rand",
	pmu=0.25, pshape=0.7, pmix=-1, prandom=-1.5) # 96.34288

gnlmix(reps, distribution="gamma", mixture="inverse Gauss",
	mu=~exp(a*rand+b*dose), random="rand", pmu=c(-1.5,0.3),
	pshape=0.7, pmix=-1.9) # 92.4003
hnlmix(reps, distribution="gamma", mixture="inverse Gauss",
	mu=~exp(b*dose+rand), random="rand",
	pmu=0.26, pshape=-0.025, pmix=-4, prandom=-1.3) # 106.4243
