library(repeated)
library(growth)
library(gnlm)
dose <- c(9,12,4,9,11,10,2,11,12,9,9,9,4,9,11,9,14,7,9,8)
#y <- round(rgamma(20,2,scale=exp(-1*rep(rgamma(4,2,scale=1/2),rep(5,4))+
#	0.3*dose)/2),2)
y <- c(1.21,16.25,0.76,1.24,4.23,12.13,0.30,14.14,2.07,1.60,6.62,21.92,1.67,
	7.75,8.83,0.70,2.52,0.35,0.38,0.18)
resp <- restovec(matrix(y, nrow=4, byrow=T), name="y", delta=0.01)
reps <- rmna(resp, tvcov=tvctomat(matrix(dose, nrow=4, byrow=T), name="dose"))

gnlr(reps, mu=~dose, pmu=c(9,0.3), psh=1) # 158.4060
gnlr(reps, mu=~dose+individuals, pmu=c(9,0.3,0,0,0), psh=1) # 157.1520
elliptic(reps, model=~dose+individuals, preg=c(12,0.6,0,0,0)) # 157.1520
elliptic(reps, model=~dose, preg=c(0,0.6), pre=4) # 158.9043
hnlmix(reps, mu=~b*dose+rand, random="rand", pmu=0.6,
	pshape=3.5, pmix=-1, prandom=-2,disp="REML") # 157.3328

gnlr(reps, distribution="gamma",mu=~exp(linear),linear=~dose,
	pmu=c(9,0.3),psh=1) # 143.9720
gnlr(reps, distribution="gamma",mu=~exp(linear),linear=~dose+individuals,
	pmu=c(9,0.3,0,0,0),psh=1) # 133.7503

print(z <- glmm(y~dose,family=Gamma(link=log),nest=individuals,
	data=reps,points=5))
z$aic/2-20*log(0.01) # 137.9034
gnlmm(reps, distribution="gamma", mu=~exp(a+b*dose), pmu=c(-2.07,0.35),
	psh=0.5, psd=1.11, points=5) # 137.9034
hnlmix(reps, distribution="gamma", mu=~exp(b*dose+rand), random="rand",
	pmu=0.25, pshape=-0.1, pmix=-1, prandom=-1.3,disp="REML") # 133.7945

gnlmix(reps, distribution="gamma", mixture="gamma",
	mu=~exp(a*rand+b*dose), random="rand", pmu=c(-2,0.34),
	pshape=0.8, pmix=1.2) # 
hnlmix(reps, distribution="gamma", mixture="gamma",
	mu=~exp(b*dose+rand), random="rand",disp="REML",
	pmu=0.25, pshape=0.7, pmix=-1, prandom=-1.5) # 134.9512

gnlmix(reps, distribution="gamma", mixture="Weibull",
	mu=~exp(a*rand+b*dose), random="rand", pmu=c(-2.2,0.33),
	pshape=0.8, pmix=0.65) # 92.77019
hnlmix(reps, distribution="gamma", mixture="Weibull",
	mu=~exp(b*dose+rand), random="rand",
	pmu=0.25, pshape=0.7, pmix=-1, prandom=-1.5) # 101.4039

gnlmix(reps, distribution="gamma", mixture="inverse Gauss",
	mu=~exp(a*rand+b*dose), random="rand", pmu=c(-2,0.34),
	pshape=0.8, pmix=-1) # 92.73247
hnlmix(reps, distribution="gamma", mixture="inverse Gauss",
	mu=~exp(b*dose+rand), random="rand",
	pmu=0.3, pshape=-1, pmix=-1, prandom=-1.5) # 203.864
