library(repeated)
library(growth)
library(gnlm)
dose <- c(14,3,15,10,8,11,10,5,7,13,8,9,12,8,11,7,12,5,9,8,8,10,6,9,14,12,15,
	11,11,11,10,14,10,13,13,11,11,9,11,9,8,8,9,8,12,18,10,8,7,17,
	11,9,11,10,15,12,10,9,11,8,12,11,8,12,16,8,13,11,14,12,9,6,10,17,10,
	14,14,6,8,10,5,6,14,6,15,11,5,11,13,19,4,8,5,11,11,12,12,6,10,7)
#y <- round(rgamma(100,2,scale=exp(-1*rep(rgamma(20,2,scale=1/2),rep(5,20))+
#	0.3*dose)/2),1)
y <- c(20.0,0.7,7.0,1.1,0.9,5.4,2.8,0.3,1.6,10.2,4.2,4.3,8.9,7.4,7.8,8.1,29.1,
	2.3,15.0,7.4,5.3,5.1,1.7,7.9,28.0,10.5,64.2,8.8,9.7,8.8,19.0,109.9,
	14.9,40.6,78.7,14.5,9.2,6.7,21.6,4.1,2.6,12.0,14.0,9.1,13.9,28.4,0.8,
	0.7,1.4,25.1,7.4,1.0,1.1,1.8,2.9,3.5,0.3,0.5,0.3,0.1,11.6,4.6,8.3,8.4,
	28.1,3.4,17.9,5.3,12.0,7.4,0.9,3.1,15.1,35.9,3.3,36.7,5.5,3.0,4.4,1.8,
	3.5,1.6,53.8,1.6,68.9,52.9,1.0,7.3,6.8,74.8,3.1,18.2,4.7,25.6,20.6,
	10.7,3.1,0.6,8.2,0.9)
resp <- restovec(matrix(y, nrow=20, byrow=T), name="y", delta=0.1)
reps <- rmna(resp, tvcov=tvctomat(matrix(dose, nrow=20, byrow=T), name="dose"))

gnlr(reps,mu=~dose, pmu=c(9,0.3),psh=10) # 648.8643
print(gnlr(reps,mu=~dose+individuals,pmu=c(9,0.3,rep(0,19)),psh=10),corr=F)
	# 635.8777
print(z <- glm(y~dose+individuals,data=reps))
z$aic/2-100*log(0.1) # 635.8777
print(elliptic(reps, model=~dose+individuals,preg=c(12,0.6,rep(0,19))),corr=F)
	# 635.8777
elliptic(reps,model=~dose,preg=c(0,0.6),pre=4) # 641.8017
print(hnlmix(reps,mu=~a+b*dose+rand,random="rand",pmu=c(-22,3.5),
	pshape=4.8,prandom=0,iter=200),corr=F) # 636.9458

gnlr(reps,distribution="gamma",mu=~exp(linear),linear=~dose,
	pmu=c(9,0.3),psh=1) # 554.272
print(z <- gnlr(reps,distribution="gamma",mu=~exp(linear),
	linear=~dose+individuals,pmu=c(9,0.3,rep(0,19)),psh=1),corr=F)
	# 519.2009
prand <- c(z$coef[1],z$coef[1]+z$coef[3:21])
prand <- prand-mean(prand)
print(z <- glmm(y~dose,family=Gamma(link=log),nest=individuals,
	data=reps,points=5))
z$aic/2-100*log(0.1) # 533.2748
print(gnlmm(reps,distribution="gamma",mu=~exp(a+b*dose),pmu=c(-2.07,0.35),
	psh=0.5,psd=0.73,points=5),corr=F) # 533.1478
print(hnlmix(reps,dist="gamma",mu=~exp(a+b*dose+rand),random="rand",
	pmu=c(-0.6,0.3),pshape=1.1,prandom=prand,iter=200),corr=F) # 521.7045

print(gnlr(reps,mu=~exp(linear),linear=~dose+individuals,
	pmu=c(-2.7,0.35,rep(0,19)),psh=10,iter=200),corr=F) # 591.8224
print(za <- glm(y~dose+individuals,family=gaussian(link=log),data=reps))
za$aic/2-100*log(0.1) # 591.8225
pranda <- c(za$coef[1],za$coef[1]+za$coef[3:21])
pranda <- pranda-mean(pranda)
elliptic(reps,model=~exp(b0+b1*dose),preg=c(-2.6,0.35),pre=4) # 639.5573
print(zam <- glmm(y~dose,nest=individuals,family=gaussian(link=log),
	points=3,data=reps))
zam$aic/2-100*log(0.1) # 616.9273
print(gnlmm(reps,mu=~exp(linear),linear=~dose,psd=1,points=5,
	pmu=c(-0.5,0.25),psh=5,iter=200),corr=F) # 645.7724
print(hnlmix(reps,mu=~exp(a+b*dose+rand),random="rand",pmu=c(-2.7,0.3),
	pshape=6.3,prandom=pranda,iter=200),corr=F) # 591.8292

gnlmix(reps,distribution="normal",mixture="gamma",
	mu=~exp(a*rand+b*dose),random="rand",pmu=c(-1.96,0.35),
	pshape=4.16,pmix=1.42) # 606.9819
print(hnlmix(reps,distribution="normal",mixture="gamma",
	mu=~exp(a+b*dose+rand),random="rand",
	pmu=c(-2.6,0.25),pshape=6,prandom=1),corr=F) # 591.9868

gnlmix(reps,distribution="gamma",mixture="gamma",
	mu=~exp(a*rand+b*dose),random="rand",pmu=c(-1.2,0.3),
	pshape=0.9,pmix=0.67) # 533.2255
print(hnlmix(reps,distribution="gamma",mixture="gamma",mu=~exp(a*rand+b*dose),
	random="rand",pmu=c(-0.9,0.3),pshape=0.9,prandom=1,iter=200),corr=F)
	# 524.5164

gnlmix(reps,distribution="gamma",mixture="Weibull",
	mu=~exp(a*rand+b*dose),random="rand",pmu=c(-1.3,0.3),
	pshape=0.9,pmix=0.38) # 533.0881
print(hnlmix(reps,distribution="gamma",mixture="Weibull",
	mu=~exp(a*rand+b*dose),random="rand",
	pmu=c(-0.9,0.3),pshape=1.1,prandom=1.1,iter=300),corr=F) # 519.8059

gnlmix(reps,distribution="gamma",mixture="inverse Gauss",
	mu=~exp(a*rand+b*dose),random="rand",pmu=c(-1.22,0.3),
	pshape=0.9,pmix=-0.62) # 533.9202
print(hnlmix(reps,distribution="gamma",mixture="inverse Gauss",
	mu=~exp(a*rand+b*dose),random="rand",
	pmu=c(-0.9,0.3),pshape=0.1,prandom=1,iter=200),corr=F) # 521.9734
